; A machine code port of the BASIC program Telengard
; Some measure was made to calculate the cycles to waste,
; however some adjustement were done by heard the result with
; the original. If one day a sid emulator will manage
; BASIC and KERNAL rom, this is a tune to re-rip.
; The timing is not so perfect: try to modify this source
; if you are able to fix it.

  processor 6502
  org 1923

 .byte "RSID"
 .word $0200         ; version 2
 .word $7C00         ; data offset
 .word $0000         ; load address in cbm format
 .byte $0000
 .byte $0000
 .byte $0000
 .byte $0000
 .word $0300         ; 3 song
 .word $0100         ; default song 2
 .word $0000
 .word $0000
 .byte "Telengard",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
 .byte "<?>",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
 .byte "1983 Avalon Hill",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
 .word $0000
 .word $0000
 .word $0000

 .byte $01
 .byte $08

; From time measurement one poke of the form f+x,y
; takes about 0,0053sec -> 5200 cycles

; for qq=1 to 10: poke fz,rnd(1)*8+200: next
; takes about 0,1402sec -> 138000 cycles

; for qq=1 to 600: next
; takes about 0,682sec -> 672000 cycles

; for i=1 to 500: next
; takes about 0,590sec ->580000 cycles

; 19000 routine:
; takes about 1,572sec -> 1548000 cycles

; if ti<1 then goto
; takes about 0.22/12sec -> 216000/12=18000 cycles

; 50225 instr:
; takes about 8 sec -> 7882000

; 50240 instr:
; takes about 9 sec ->

        cmp  #$00
        bne  nn1
        
        jmp  titlepage

nn1:
        cmp  #$01
        bne  nn2
        jmp  throme

nn2:
        lda  #1
        sta  $8E
        jmp  chime



; 19000 ti$="000000"
; 19002 if ti<90then 19002
; 19003 return
r19000:
        jsr  C1548000
        rts

chime:
; 50100 rem *chime i times*
; 50105 poke f1+1,11:
        lda  #11
        sta  $D401
        jsr  C2600

;       poke f1,0:
        lda  #0
        sta  $D400
        jsr  C2600

;       poke f+5,43:
        lda  #43
        sta  $D405
        jsr  C2600

;       poke f+6,0:
        lda  #0
        sta  $D406
        jsr  C2600

;       poke f3+1,5:
        lda  #5
        sta  $D40F
        jsr  C2600

;       poke f3,0:
        lda  #0
        sta  $D40E
        jsr  C2600

;       poke fv,15
        lda  #15
        sta  $D418
        jsr  C2600

; 50110 for q=1 to i:
        lda  $8E
        jsr  C5200

nextq:

; poke f4,20:
        lda  #20
        sta  $D404
        jsr  C5200
        jsr  C5200  ; add some more delay
        jsr  C5200  ; add some more delay
        jsr  C5200  ; add some more delay
        jsr  C5200  ; add some more delay
        jsr  C5200  ; add some more delay
        jsr  C5200  ; add some more delay
        
; poke f4,21:
        lda  #21
        sta  $D404
        jsr  C5200

; for qq=1 to 10: poke fz,rnd(1)*8+200: next
        jsr  C138000

; 50112 for qq=1 to 600
; 50120 next:
        jsr  C672000

; next:
        jsr  C5200
        dec  $8E
        lda  $8E
        bne  nextq

; poke f4,20:
        lda  #20
        sta  $D404
        jsr  C2600

; gosub 19000:
        jsr  r19000

; poke fv,0:
        lda  #00
        sta  $D418
        jsr  C2600

; poke fz,200:
        jsr  C5200

; return
        rts


titlepage:
;50200 rem *titlepage music*
;50205 poke f+5,144: poke f+6,217: poke f+12,251: poke f+13,27: poke f+19,251: poke f+20,27
        lda  #144
        sta  $D405
        jsr  C2600

        lda  #217
        sta  $D406
        jsr  C2600

        lda  #251
        sta  $D40C
        jsr  C2600

        lda  #27
        sta  $D40D
        jsr  C2600

        lda  #251
        sta  $D413
        jsr  C2600

        lda  #27
        sta  $D414
        jsr  C2600

;50210 poke f3,70: poke f3+1,6: poke f5,0
        lda  #70
        sta  $D40E
        jsr  C2600

        lda  #6
        sta  $D40F
        jsr  C2600

        lda  #0
        sta  $D40B
        jsr  C2600


;50215 poke fv,8: for j=1 to 500: next: poke f6,129: ti$="000000"
        lda  #8
        sta  $D418
        jsr  C2600

        jsr  C580000

        lda  #129
        sta  $D412
        jsr  C5200

;50225 poke fz,rnd(1)*4+200: if ti<480 then 50225

        jsr  C1548000
        jsr  C1548000
        jsr  C1548000
        jsr  C1548000
        jsr  C1548000


;50230 poke f2,251: poke f2+1,9: poke f5,129: ti$="000000"
        lda  #251
        sta  $D407
        jsr  C2600
        
        lda  #9
        sta  $D408
        jsr  C2600
        
        lda  #129
        sta  $D40b
        jsr  C5200

;50240 poke fz,rnd(1)*4+200: if ti<540 then 50240
        jsr  C1548000
        jsr  C1548000
        jsr  C1548000
        jsr  C1548000
        jsr  C1548000
        jsr  C580000
        ;jsr  C580000


;50245 poke f6,0:poke f+19,16: poke f+20,215: f(0)=17: f(1)=129: f(2)=17: poke fv,15
        lda  #0
        sta  $D412
        jsr  C2600
        
        lda  #16
        sta  $D413
        jsr  C2600
        
        lda  #215
        sta  $D414
        jsr  C2600
        
        lda  #17
        sta  val
        jsr  C2600

        lda  #129
        sta  val+7
        jsr  C2600

        lda  #17
        sta  val+14
        jsr  C2600

        lda  #15
        sta  $D418
        jsr  C2600

;50247 poke sz,200: poke f+5,16: poke f+6,215
        jsr  C2600
       
        lda  #16
        sta  $D405
        jsr  C2600

        lda  #215
        sta  $D406
        jsr  C2600

;50250 ff=ft: gosub 50500
        lda  #<tuneA
        sta  $8B
        lda  #>tuneA
        sta  $8C
        jsr  C5200

        jsr  sequencer


;50255 i=5: gosub 50100
        lda  #5
        sta  $8E
        jsr  C2600
        jsr  chime

;50295 q=aq+1: poke f4,0: poke f5,0: poke f6,0: for q=0 to 24: poke f+q,0: next: return
        lda  #0
        sta  $D404
        jsr  C5200
        
        lda  #0
        sta  $D40b
        jsr  C2600

        lda  #0
        sta  $D412
        jsr  C2600
        
        ldx  #0
loop77:
        lda  #0
        sta  $D400,x
        jsr  C5200
        inx
        txa
        cmp  #25
        bne  loop77
        rts

        rts



sequencer:
; 50500 rem *music sequencer*
; 50502 k=f1+1
        ldy  #$00
        jsr  C2600

seq_next:
; 50505 ti$="000000": fs=peek(ff)*3: if fs=0 then return
        jsr  C5200
        lda  ($8B),y
        sta  $8D
        clc
        adc  $8D
        adc  $8D
        sta  $8D
        cmp  #00
        bne  cont22
        rts

cont22:

; 50515 ff=ff+1: for i=0 to 2: q=peek(ff): if q=0 then 50520
        iny
        jsr  C2600

        ldx  #$00
        jsr  C2600

nextSeq:
        jsr  C2600
        lda  ($8B),y
        beq  nextVoice


; 50516 if q=255 then poke f4+i*7,0: goto 50520
        jsr  C2600
        cmp  #255
        bne  continue

        lda  #00
        sta  $D404,x
        jsr  C5200
        jmp  nextVoice

continue:
; 50517 poke f1+i*7,nt%(q) and th: poke k+i*7,nt%(q)/tf: poke f4+i*7,f(i)
        sta  $8E
        tya
        pha
        ldy  $8E

        lda  low,y
        sta  $D400,x
        jsr  C5200

        lda  hi,y
        sta  $D401,x
        jsr  C5200

        lda  val,x
        sta  $D404,x
        jsr  C5200
        pla
        tay

nextVoice:
; 50520 ff=ff+1: next i
        jsr  C2600
        iny
        txa
        clc
        adc  #$07
        tax
        cmp  #$15
        bne  nextSeq


; 50535 if ti<fs then 50535
        lda  $8D
        sbc  $06   ; some cycles are already wastle
loop2:
        jsr  C18000
        sec
        sbc  #$01
        bne  loop2


; 50540 goto 50505
        jsr  C2600
        jmp  seq_next


throme:
; 50600 rem *throne music*
; 50605 for fq=0 to 2: poke f+5+fq*7,18: poke f+6+fq*7,244: f(fq)=17: next: ff=38545
        lda  #18
        sta  $D405
        jsr  C5200

        lda  #244
        sta  $D406
        jsr  C5200

        lda  #17
        sta  val
        jsr  C5200

        lda  #18
        sta  $D40C
        jsr  C5200

        lda  #244
        sta  $D40D
        jsr  C5200

        lda  #17
        sta  val+7
        jsr  C5200

        lda  #18
        sta  $D413
        jsr  C5200

        lda  #244
        sta  $D414
        jsr  C5200

        lda  #17
        sta  val+14
        jsr  C5200

        lda  #<tuneB
        sta  $8B
        lda  #>tuneB
        sta  $8C
        jsr  C5200


; 50610 poke fv,10:
        lda  #10
        sta  $D418
        jsr  C5200

; gosub 50500:
        jsr  sequencer

; goto 50750
; 50750 rem *turn sound off*
; 50755 for fq=0 to 24: poke f+fq,0: next :return

        ldx  #0
loop1:
        lda  #0
        sta  $D400,x
        jsr  C5200
        inx
        txa
        cmp  #25
        bne  loop1
        rts


; waste 5200 about cycles
C5200:
        pha
        txa
        pha
        tya
        pha
        ldx  #$00             ; 2
rep2:
        lda  ($33,x)          ; 6
        lda  ($34,x)          ; 6
        lda  $3334            ; 4
        dex                   ; 2
        bne  rep2             ; 2
        pla
        tay
        pla
        tax
        pla
        rts                   ; 6

 ; waste 2600 about cycles
C2600:
        pha
        txa
        pha
        tya
        pha
        ldx  #129             ; 2
rep20:
        lda  ($33,x)          ; 6
        lda  ($34,x)          ; 6
        lda  $3334            ; 4
        dex                   ; 2
        bne  rep20            ; 2
        pla
        tay
        pla
        tax
        pla
        rts                   ; 6

; waste 138000 about cycles
; add some nops as too fast
C138000:
        pha
        txa
        pha
        tya
        pha
        ldx  #$00             ; 2
rep3:
        ldy  #134             ; 2
rep1:
        nop ;
        nop ;
        nop ;
        nop ;
        dey                   ; 2
        bne  rep1             ; 2
        dex                   ; 2
        bne  rep3             ; 2
        pla
        tay
        pla
        tax
        pla
        rts                   ; 6

; waste 18000 about cycles
; fix: 18000 are too many: from #17 -> #12
C18000:
        pha
        txa
        pha
        tya
        pha
        ldx  #$00             ; 2
rep33:
        ldy  #12              ; 2
rep11:
        dey                   ; 2
        bne  rep11            ; 2
        dex                   ; 2
        bne  rep33            ; 2
        pla
        tay
        pla
        tax
        pla
        rts                   ; 6


; waste 672000 about cycles
C672000:
        pha
        txa
        pha
        tya
        pha
        ldx  #$00             ; 2
rep4:
        ldy  #219             ; 2
rep5:
        lda  ($33,x)          ; 6
        nop                   ; 2
        dey                   ; 2
        bne  rep5             ; 2
        lda  $33              ; 3
        dex                   ; 2
        bne  rep4             ; 2
        pla
        tay
        pla
        tax
        pla
        rts                   ; 6


; waste 580000 about cycles
C580000:
        pha
        txa
        pha
        tya
        pha
        ldx  #$00             ; 2
rep44:
        ldy  #189             ; 2
rep55:
        lda  ($33,x)          ; 6
        nop                   ; 2
        dey                   ; 2
        bne  rep55            ; 2
        lda  $33              ; 3
        dex                   ; 2
        bne  rep44            ; 2
        pla
        tay
        pla
        tax
        pla
        rts                   ; 6

; waste 1548000 about cycles
C1548000:
        pha
        txa
        pha
        tya
        pha
        ldx  #$00             ; 2
rep6:
        ldy  #216             ; 2
rep7:
        lda  ($33,x)          ; 6
        lda  ($33,x)          ; 6
        lda  ($33,x)          ; 6
        lda  ($33,x)          ; 6
        dey                   ; 2
        bne  rep7             ; 2
        lda  ($33,x)          ; 6
        lda  ($33,x)          ; 6
        lda  ($33,x)          ; 6
        nop                   ; 2
        dex                   ; 2
        bne  rep6             ; 2
        pla
        tay
        pla
        tax
        pla
        rts                   ; 6

low:
  .byte  12,  27,  44,  62,  81, 101, 123, 145
  .byte 194, 221, 250,  24,  55,  89, 125, 163
  .byte 203, 246,  35,  83, 133, 187, 244,  48
  .byte 112, 179, 251,  71, 151, 236,  70, 166
  .byte  11, 118, 232,  96, 224, 103, 246, 142
  .byte  46, 217, 141,  76,  23, 237, 208, 193
  .byte 192, 206, 237,  28,  93, 178,  27, 153
  .byte  46, 219, 162

hi:
  .byte   1,   1,   1,   1,   1,   1,   1,   1
  .byte   1,   1,   1,   2,   2,   2,   2,   2
  .byte   2,   2,   3,   3,   3,   3,   3,   4
  .byte   4,   4,   4,   5,   5,   5,   6,   6
  .byte   7,   7,   7,   8,   8,   9,   9,  10
  .byte  11,  11,  12,  13,  14,  14,  15,  16
  .byte  17,  18,  19,  21,  22,  23,  25,  26
  .byte  28,  29,  31


tuneA:
  .byte $20, $24, $00, $1f,  $20, $27, $00, $24
  .byte $10, $26, $00, $1a,  $08, $24, $00, $00
  .byte $08, $22, $00, $00,  $10, $24, $00, $00
  .byte $10, $1f, $00, $00,  $20, $24, $00, $1f
  .byte $20, $27, $00, $24,  $08, $29, $00, $26
  .byte $08, $27, $00, $24,  $08, $26, $00, $22
  .byte $08, $24, $00, $21,  $20, $26, $00, $22
  .byte $04, $ff, $00, $ff,  $10, $24, $00, $30
  .byte $10, $00, $00, $2b,  $10, $27, $00, $2b
  .byte $08, $00, $00, $2e,  $08, $00, $00, $30
  .byte $10, $26, $00, $32,  $08, $24, $00, $2b
  .byte $08, $22, $00, $00,  $10, $24, $00, $2b
  .byte $10, $1f, $00, $32,  $10, $24, $00, $30
  .byte $10, $00, $00, $2b,  $10, $27, $00, $2b
  .byte $08, $00, $00, $2e,  $08, $00, $00, $30
  .byte $08, $29, $00, $2e,  $08, $27, $00, $00
  .byte $08, $26, $00, $00,  $08, $24, $00, $00
  .byte $20, $26, $1b, $00,  $30, $ff, $00, $ff
  .byte $00

tuneB:
  .byte $04, $2f, $2b, $23,  $04, $31, $2d, $25
  .byte $04, $32, $2f, $26,  $04, $34, $31, $28
  .byte $04, $36, $32, $2a,  $04, $32, $2f, $26
  .byte $0a, $36, $32, $2a,  $04, $35, $30, $29
  .byte $04, $31, $2d, $25,  $0a, $35, $30, $29
  .byte $04, $34, $31, $28,  $04, $30, $2c, $24
  .byte $0a, $34, $31, $28,  $04, $2f, $2b, $23
  .byte $04, $31, $2d, $25,  $04, $32, $2f, $26
  .byte $04, $34, $31, $28,  $04, $36, $32, $2a
  .byte $04, $32, $2f, $26,  $04, $36, $32, $2a
  .byte $04, $3b, $37, $2f,  $04, $39, $36, $2d
  .byte $04, $36, $32, $2a,  $04, $32, $2f, $26
  .byte $04, $34, $31, $28,  $0a, $36, $32, $2a
  .byte $00

val:
  ; some bytes are used here
  .byte $00
